=== build/docker/Makefile ===

ROOT=../..
include $(ROOT)/deps/readies/mk/main

REPO=redistimeseries

REDIS_VERSION=6.2.7

OSNICK.official=bullseye

INT_BRANCHES=1.8 1.6 1.4
LATEST_BRANCH=1.6
PREVIEW_BRANCH=1.8

ART_DIR=$(ROOT)/bin/artifacts

include $(MK)/module.docker.rules
