=== debian/changelog ===
redis-timeseries-src (1.6.19.6-1) stable; urgency=medium

  * Changed: No public changes

 -- Fabian Kalweit <f.kalweit@uib.de>  Wed, 17 Jul 2024 14:13:26 +0200

redis-timeseries-src (1.6.19.4-1) stable; urgency=medium

  * Changed: new Version 1.6.19.4
  * Changed: new version (opsi v4.3)

 -- Fabian Kalweit <f.kalweit@uib.de>  Wed, 15 May 2024 12:00:41 +0200

redis-timeseries-src (1.6.19.3-1) stable; urgency=medium

  * Changed: No public changes

 -- Fabian Kalweit <f.kalweit@uib.de>  Mon, 04 Sep 2023 09:27:10 +0200
