=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

clean:
	dh_testdir
	dh_clean
	rm -f debian/files || true

build:
	python3 --version
	make build MK.pyver=3
	mkdir -p rootfs/usr/lib/redis/modules
	if [ -f bin/linux-x64-release/redistimeseries.so ]; then cp bin/linux-x64-release/redistimeseries.so rootfs/usr/lib/redis/modules/; fi;
	if [ -f bin/linux-arm64v8-release/redistimeseries.so ]; then cp bin/linux-arm64v8-release/redistimeseries.so rootfs/usr/lib/redis/modules/; fi;
	

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	
	$(eval sys_arch=$(shell dpkg --print-architecture))
	if [ -d rootfs ]; then cp -a rootfs/* debian/redis-timeseries/; fi;
	if [ -d rootfs-$(sys_arch) ]; then cp -a rootfs-$(sys_arch)/* debian/redis-timeseries/; fi;
	
	dh_install

binary-indep: install
	dh_testdir -i
	dh_installdebconf
	dh_installchangelogs
	dh_installdocs
	dh_md5sums
	dh_gencontrol
	dh_installdeb
	dh_builddeb

binary: binary-indep
build:
.PHONY: clean binary-indep binary install build
